<template>
  <div class="modelAdd container">
    <b-steps v-model="activeStep">
      <b-step-item step="1" label="Description" clickable>
        <b-field label="Model name">
          <b-input minlength="3" maxlength="100" size="is-large" v-model="model.name"/>
        </b-field>

        <b-field label="Short description">
          <b-input maxlength="200" type="textarea" v-model="model.shortDescription"/>
        </b-field>

        <b-field label="Long description">
          <markdownEditor v-bind:input="model.longDescription" v-on:update-description="model.longDescription = $event"/>
        </b-field>

        <b-field label="Performance">
          <b-field>
            <b-input type="number" placeholder="98" max="10000000" step="0.01" v-model="model.performance"/>
            <b-autocomplete open-on-focus placeholder="accuracy" :data="performanceTypes" v-model="model.performanceUnit" maxlength="50"/>
            <b-checkbox-button v-model="model.performanceLowerIsBetter" type="is-success">Lower is better</b-checkbox-button>
          </b-field>
        </b-field>

        <b-field label="Number of parameters">
          <b-input type="number" min="0" max="10000000" placeholder="0" v-model="model.parameterCount"/>
        </b-field>
      </b-step-item>

      <b-step-item step="2" label="Tags" clickable>
        <tagEditor v-bind:tags="model.tags" v-on:update-tags="model.tags = $event"/>
      </b-step-item>

      <b-step-item step="3" label="Files" clickable>
        <b-field label="Model">
          <b-upload v-model="model.file" drag-drop expanded>
            <section class="section">
              <div class="content has-text-centered">
                <p>
                  <b-icon icon="upload" size="is-large"/>
                </p>
                <p>Drop your model here or click to upload</p>
              </div>
            </section>
          </b-upload>
          <span v-if="model.file" class="file-name">{{ model.file.name }}</span>
        </b-field>
      </b-step-item>

      <b-step-item step="4" label="Custom layers" clickable>
        <layersEditor v-bind:layers="model.customLayers" v-on:update-layers="model.customLayers = $event"/>
      </b-step-item>

      <b-step-item step="5" label="Finish" clickable>
        <b-button expanded size="is-large" type="is-success" @click="openUploadModal">Confirm and upload</b-button>
      </b-step-item>

    </b-steps>

    <b-modal :active.sync="isUploadModalActive" has-modal-card trap-focus aria-role="dialog" aria-modal>
      <ModelUpload v-bind:model="model"/>
    </b-modal>
  </div>
</template>

<script>
import markdownEditor from '@/components/MarkdownEditor.vue'
import tagEditor from '@/components/TagEditor.vue'
import layersEditor from '@/components/LayersEditor.vue'
import ModelUpload from '@/components/ModelUpload.vue'

export default {
  name: 'ModelAdd',
  components: {
    markdownEditor,
    tagEditor,
    layersEditor,
    ModelUpload
  },
  data () {
    return {
      model: {},
      activeStep: 0,
      isUploadModalActive: false,
      performanceTypes: [
        'accuracy',
        'error rate',
        'MSE'
      ]
    }
  },
  methods: {
    openUploadModal () {
      this.isUploadModalActive = true
    }
  }
}
</script>

<style scoped>
.modelAdd {
  margin-top: 20px;
}
</style>
